package {
	import FlyWeightPieceFactory;
	import ChessPieceData;
	import flash.display.Sprite;
	import flash.display.StageScaleMode;
	import flash.events.MouseEvent;
	import flash.events.Event;
	public class flyWeight_chess extends Sprite{
		private var boardMatrix:Array;
		private var _whitesMove:Boolean;
		public function flyWeight_chess(){
			stage.scaleMode=StageScaleMode.NO_SCALE;
			stage.align='TL';
			boardMatrix=new Array(64);
			y=55;
			scaleY=8/9;
			_setup("RNBQKBNRPPPPPPPP00000000000000000000000000000000pppppppprnbqkbnr");
			addEventListener(MouseEvent.MOUSE_DOWN, _grabPiece);
			addEventListener(MouseEvent.MOUSE_UP, _dropPiece);
			_whitesMove=true;
			//makeAMove();
		}
		private function _setup(postionUKey:String):void{
			var stateArray:Array=postionUKey.split('');
			for (var i:uint=0; i<64; i++) {
				_createSquare(i, stateArray[i]);
			}		
		}
		private const SQAURESIZE:uint=75;
		private function _createSquare(sqId:uint,pieceId:String):void{
			var x:int=(sqId%8)*SQAURESIZE;
			var y:int=((sqId/8)|0)*SQAURESIZE;
			var sqColor:Number=(x+y)%2==0?0:0xFFFFFF;
			graphics.beginFill(sqColor);
			graphics.drawRect(x,y,SQAURESIZE,SQAURESIZE);
			if(pieceId!='0'){
				var strId:String=pieceId.toUpperCase();
				var white:Boolean=strId!=pieceId;
				var pieceData:ChessPieceData=FlyWeightPieceFactory.getFlyWeight(strId);
				var piece:ChessPiece=new ChessPiece(pieceData,white,x,y-SQAURESIZE);
				addChild(piece.getSprite());
				boardMatrix[sqId]=piece;
			}else{
				addChild(new Sprite());
			}
		}
		private var _selected:ChessPiece;
		private var _startMoveId:int;
		private function _grabPiece(event:Event):void{
			var sqId:int=getFocusSqId();
			if(sqId==-1){
				return;
			}
			var touch:ChessPiece=boardMatrix[sqId];
			if(touch!=null && _whitesMove == touch.isWhite()){
				_selected=touch;
				var sprite:Sprite = _selected.getSprite();
				sprite.startDrag();
				setChildIndex(sprite,63);
				_startMoveId=sqId;
			}else{
				_selected=null;
			}
		}
		private function _dropPiece(event:Event):void{
			if(_selected!=null){
				var sprite:Sprite = _selected.getSprite();
				sprite.stopDrag();
				var sqId:int=getFocusSqId();
				if(sqId==-1 || sqId== _startMoveId || !_selected.validMove(_startMoveId,sqId,boardMatrix[sqId])){
					_selected.reset();
					setChildIndex(sprite,_startMoveId);
					_selected=null;
					return;
				}
				var x:int=(sqId%8)*SQAURESIZE;
				var y:int=((sqId/8)|0)*SQAURESIZE;
				_selected.setPosition(x,y-SQAURESIZE);
				boardMatrix[_startMoveId]=null;
				if(boardMatrix[sqId]!=undefined){
					removeChild(boardMatrix[sqId].getSprite());
					addChildAt(new Sprite(),sqId);
				}
				boardMatrix[sqId]=_selected;
				setChildIndex(sprite,sqId);
				_whitesMove=!_whitesMove;
				_selected=null;
			}
		}
		private function getFocusSqId():int{
			if(mouseX>0 && mouseX< SQAURESIZE*8){
				if(mouseY>0 && mouseY< SQAURESIZE*8){
					return ((mouseX/75) | 0)+((mouseY/75) |0)*8;
				}
			}
			return -1;
		}
	}
}
